# Generated by Django 2.2.3 on 2019-09-23 08:15

from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone
import jutil.validators


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('jacc', '0019_entrytype_identifier'),
    ]

    operations = [
        migrations.CreateModel(
            name='CurrencyExchange',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('record_date', models.DateField(db_index=True, verbose_name='record date')),
                ('source_currency', models.CharField(blank=True, max_length=3, verbose_name='source currency')),
                ('target_currency', models.CharField(blank=True, max_length=3, verbose_name='target currency')),
                ('unit_currency', models.CharField(blank=True, max_length=3, verbose_name='unit currency')),
                ('exchange_rate', models.DecimalField(blank=True, decimal_places=6, default=None, max_digits=12, null=True, verbose_name='exchange rate')),
            ],
            options={
                'verbose_name': 'currency exchange',
                'verbose_name_plural': 'currency exchanges',
            },
        ),
        migrations.CreateModel(
            name='CurrencyExchangeSource',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=64, verbose_name='name')),
                ('created', models.DateTimeField(blank=True, db_index=True, default=django.utils.timezone.now, editable=False, verbose_name='created')),
            ],
            options={
                'verbose_name': 'currency exchange source',
                'verbose_name_plural': 'currency exchange sources',
            },
        ),
        migrations.CreateModel(
            name='Payout',
            fields=[
                ('accountentry_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='jacc.AccountEntry')),
                ('messages', models.TextField(blank=True, default='', verbose_name='recipient messages')),
                ('reference', models.CharField(blank=True, default='', max_length=32, verbose_name='recipient reference')),
                ('msg_id', models.CharField(blank=True, db_index=True, editable=False, max_length=64, verbose_name='message id')),
                ('file_name', models.CharField(blank=True, db_index=True, editable=False, max_length=255, verbose_name='file name')),
                ('full_path', models.TextField(blank=True, editable=False, verbose_name='full path')),
                ('file_reference', models.CharField(blank=True, db_index=True, editable=False, max_length=255, verbose_name='file reference')),
                ('due_date', models.DateField(blank=True, db_index=True, default=None, null=True, verbose_name='due date')),
                ('paid_date', models.DateTimeField(blank=True, db_index=True, default=None, null=True, verbose_name='paid date')),
                ('state', models.CharField(blank=True, choices=[('W', 'waiting processing'), ('U', 'waiting upload'), ('D', 'uploaded'), ('P', 'paid'), ('C', 'canceled'), ('E', 'error')], db_index=True, default='W', max_length=1, verbose_name='state')),
            ],
            options={
                'verbose_name': 'payout',
                'verbose_name_plural': 'payouts',
            },
            bases=('jacc.accountentry',),
        ),
        migrations.CreateModel(
            name='ReferencePaymentBatch',
            fields=[
                ('accountentrysourcefile_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='jacc.AccountEntrySourceFile')),
                ('record_date', models.DateTimeField(db_index=True, verbose_name='record date')),
                ('institution_identifier', models.CharField(blank=True, max_length=2, verbose_name='institution identifier')),
                ('service_identifier', models.CharField(blank=True, max_length=9, verbose_name='service identifier')),
                ('currency_identifier', models.CharField(choices=[('1', 'EUR')], max_length=3, verbose_name='currency identifier')),
            ],
            options={
                'verbose_name': 'reference payment batch',
                'verbose_name_plural': 'reference payment batches',
            },
            bases=('jacc.accountentrysourcefile',),
        ),
        migrations.CreateModel(
            name='ReferencePaymentBatchFile',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', models.DateTimeField(blank=True, db_index=True, default=django.utils.timezone.now, editable=False, verbose_name='created')),
                ('file', models.FileField(upload_to='uploads', verbose_name='file')),
                ('errors', models.TextField(blank=True, default='', max_length=4086, verbose_name='errors')),
            ],
            options={
                'verbose_name': 'reference payment batch file',
                'verbose_name_plural': 'reference payment batch files',
            },
        ),
        migrations.CreateModel(
            name='Statement',
            fields=[
                ('accountentrysourcefile_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='jacc.AccountEntrySourceFile')),
                ('account_number', models.CharField(db_index=True, max_length=32, verbose_name='account number')),
                ('statement_identifier', models.CharField(blank=True, db_index=True, default='', max_length=48, verbose_name='statement identifier')),
                ('statement_number', models.SmallIntegerField(db_index=True, verbose_name='statement number')),
                ('begin_date', models.DateField(db_index=True, verbose_name='begin date')),
                ('end_date', models.DateField(db_index=True, verbose_name='end date')),
                ('record_date', models.DateTimeField(db_index=True, verbose_name='record date')),
                ('customer_identifier', models.CharField(blank=True, default='', max_length=64, verbose_name='customer identifier')),
                ('begin_balance_date', models.DateField(verbose_name='begin balance date')),
                ('begin_balance', models.DecimalField(decimal_places=2, max_digits=10, verbose_name='begin balance')),
                ('record_count', models.IntegerField(default=None, null=True, verbose_name='record count')),
                ('currency_code', models.CharField(max_length=3, verbose_name='currency code')),
                ('account_name', models.CharField(blank=True, default='', max_length=32, verbose_name='account name')),
                ('account_limit', models.DecimalField(blank=True, decimal_places=2, default=None, max_digits=10, null=True, verbose_name='account limit')),
                ('owner_name', models.CharField(max_length=64, verbose_name='owner name')),
                ('contact_info_1', models.CharField(blank=True, default='', max_length=64, verbose_name='contact info (1)')),
                ('contact_info_2', models.CharField(blank=True, default='', max_length=64, verbose_name='contact info (2)')),
                ('bank_specific_info_1', models.CharField(blank=True, default='', max_length=1024, verbose_name='bank specific info (1)')),
                ('iban', models.CharField(db_index=True, max_length=32, verbose_name='IBAN')),
                ('bic', models.CharField(db_index=True, max_length=8, verbose_name='BIC')),
                ('account', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='+', to='jacc.Account')),
            ],
            options={
                'verbose_name': 'statement',
                'verbose_name_plural': 'statements',
            },
            bases=('jacc.accountentrysourcefile',),
        ),
        migrations.CreateModel(
            name='StatementFile',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', models.DateTimeField(blank=True, db_index=True, default=django.utils.timezone.now, editable=False, verbose_name='created')),
                ('file', models.FileField(upload_to='uploads', verbose_name='file')),
                ('errors', models.TextField(blank=True, default='', max_length=4086, verbose_name='errors')),
            ],
            options={
                'verbose_name': 'account statement file',
                'verbose_name_plural': 'account statement files',
            },
        ),
        migrations.CreateModel(
            name='StatementRecord',
            fields=[
                ('accountentry_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='jacc.AccountEntry')),
                ('line_number', models.SmallIntegerField(blank=True, default=None, null=True, verbose_name='line number')),
                ('record_number', models.IntegerField(blank=True, default=None, null=True, verbose_name='record number')),
                ('archive_identifier', models.CharField(blank=True, db_index=True, default='', max_length=64, verbose_name='archive identifier')),
                ('record_date', models.DateField(db_index=True, verbose_name='record date')),
                ('value_date', models.DateField(blank=True, db_index=True, default=None, null=True, verbose_name='value date')),
                ('paid_date', models.DateField(blank=True, db_index=True, default=None, null=True, verbose_name='paid date')),
                ('entry_type', models.CharField(choices=[('1', 'Deposit'), ('2', 'Withdrawal'), ('3', 'Deposit Correction'), ('4', 'Withdrawal Correction')], db_index=True, max_length=1, verbose_name='entry type')),
                ('record_code', models.CharField(blank=True, choices=[('700', 'Money Transfer (In/Out)'), ('701', 'Recurring Payment (In/Out)'), ('702', 'Bill Payment (Out)'), ('703', 'Payment Terminal Deposit (In)'), ('704', 'Bank Draft (In/Out)'), ('705', 'Reference Payments (In)'), ('706', 'Payment Service (Out)'), ('710', 'Deposit (In)'), ('720', 'Withdrawal (Out)'), ('721', 'Card Payment (Out)'), ('722', 'Check (Out)'), ('730', 'Bank Fees (Out)'), ('740', 'Interests Charged (Out)'), ('750', 'Interests Credited (In)'), ('760', 'Loan (Out)'), ('761', 'Loan Payment (Out)'), ('770', 'Foreign Transfer (In/Out)'), ('780', 'Zero Balancing (In/Out)'), ('781', 'Sweeping (In/Out)'), ('782', 'Topping (In/Out)')], db_index=True, max_length=4, verbose_name='record type')),
                ('record_domain', models.CharField(blank=True, choices=[('PMNT', 'Money Transfer (In/Out)'), ('LDAS', 'Loan Payment (Out)'), ('CAMT', 'Cash Management'), ('ACMT', 'Account Management'), ('XTND', 'Entended Domain'), ('SECU', 'Securities'), ('FORX', 'Foreign Exchange'), ('XTND', 'Entended Domain'), ('NTAV', 'Not Available')], db_index=True, max_length=4, verbose_name='record domain')),
                ('family_code', models.CharField(blank=True, db_index=True, default='', max_length=4, verbose_name='family code')),
                ('sub_family_code', models.CharField(blank=True, db_index=True, default='', max_length=4, verbose_name='sub family code')),
                ('record_description', models.CharField(blank=True, default='', max_length=128, verbose_name='record description')),
                ('receipt_code', models.CharField(blank=True, choices=[('', ''), ('E', 'Separate'), ('P', 'Separate/Paper')], db_index=True, max_length=1, verbose_name='receipt code')),
                ('delivery_method', models.CharField(choices=[('A', 'From Customer'), ('K', 'From Bank Clerk'), ('J', 'From Bank System')], db_index=True, max_length=1, verbose_name='delivery method')),
                ('name', models.CharField(blank=True, db_index=True, max_length=64, verbose_name='name')),
                ('name_source', models.CharField(blank=True, choices=[('', 'Not Set'), ('A', 'From Customer'), ('K', 'From Bank Clerk'), ('J', 'From Bank System')], max_length=1, verbose_name='name source')),
                ('recipient_account_number', models.CharField(blank=True, db_index=True, max_length=32, verbose_name='recipient account number')),
                ('recipient_account_number_changed', models.CharField(blank=True, max_length=1, verbose_name='recipient account number changed')),
                ('remittance_info', models.CharField(blank=True, db_index=True, max_length=35, verbose_name='remittance info')),
                ('messages', models.TextField(blank=True, default='', verbose_name='messages')),
                ('client_messages', models.TextField(blank=True, default='', verbose_name='client messages')),
                ('bank_messages', models.TextField(blank=True, default='', verbose_name='bank messages')),
                ('manually_settled', models.BooleanField(blank=True, db_index=True, default=False, verbose_name='manually settled')),
                ('statement', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='record_set', to='jbank.Statement', verbose_name='statement')),
            ],
            options={
                'verbose_name': 'statement record',
                'verbose_name_plural': 'statement records',
            },
            bases=('jacc.accountentry',),
        ),
        migrations.CreateModel(
            name='StatementRecordDetail',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('batch_identifier', models.CharField(blank=True, db_index=True, default='', max_length=64, verbose_name='batch message id')),
                ('amount', models.DecimalField(blank=True, db_index=True, decimal_places=2, default=None, max_digits=10, null=True, verbose_name='amount')),
                ('currency_code', models.CharField(max_length=3, verbose_name='currency code')),
                ('instructed_amount', models.DecimalField(blank=True, db_index=True, decimal_places=2, default=None, max_digits=10, null=True, verbose_name='instructed amount')),
                ('archive_identifier', models.CharField(blank=True, max_length=64, verbose_name='archive identifier')),
                ('end_to_end_identifier', models.CharField(blank=True, max_length=64, verbose_name='end-to-end identifier')),
                ('creditor_name', models.CharField(blank=True, max_length=128, verbose_name='creditor name')),
                ('creditor_account', models.CharField(blank=True, max_length=35, verbose_name='creditor account')),
                ('debtor_name', models.CharField(blank=True, max_length=128, verbose_name='debtor name')),
                ('ultimate_debtor_name', models.CharField(blank=True, max_length=128, verbose_name='ultimate debtor name')),
                ('unstructured_remittance_info', models.CharField(blank=True, max_length=2048, verbose_name='unstructured remittance info')),
                ('paid_date', models.DateTimeField(blank=True, db_index=True, default=None, null=True, verbose_name='paid date')),
                ('exchange', models.ForeignKey(blank=True, default=None, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='recorddetail_set', to='jbank.CurrencyExchange', verbose_name='currency exchange')),
                ('record', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='detail_set', to='jbank.StatementRecord', verbose_name='record')),
            ],
        ),
        migrations.CreateModel(
            name='Refund',
            fields=[
                ('payout_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='jbank.Payout')),
            ],
            options={
                'verbose_name': 'refund',
                'verbose_name_plural': 'refunds',
            },
            bases=('jbank.payout',),
        ),
        migrations.CreateModel(
            name='StatementRecordSepaInfo',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('reference', models.CharField(blank=True, max_length=35, verbose_name='reference')),
                ('iban_account_number', models.CharField(blank=True, max_length=35, verbose_name='IBAN')),
                ('bic_code', models.CharField(blank=True, max_length=35, verbose_name='BIC')),
                ('recipient_name_detail', models.CharField(blank=True, max_length=70, verbose_name='recipient name detail')),
                ('payer_name_detail', models.CharField(blank=True, max_length=70, verbose_name='payer name detail')),
                ('identifier', models.CharField(blank=True, max_length=35, verbose_name='identifier')),
                ('archive_identifier', models.CharField(blank=True, max_length=64, verbose_name='archive identifier')),
                ('record', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, related_name='sepa_info', to='jbank.StatementRecord', verbose_name='record')),
            ],
            options={
                'verbose_name': 'SEPA',
                'verbose_name_plural': 'SEPA',
            },
        ),
        migrations.CreateModel(
            name='StatementRecordRemittanceInfo',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('additional_info', models.CharField(blank=True, db_index=True, max_length=64, verbose_name='additional remittance info')),
                ('amount', models.DecimalField(blank=True, decimal_places=2, default=None, max_digits=10, null=True, verbose_name='amount')),
                ('currency_code', models.CharField(blank=True, max_length=3, verbose_name='currency code')),
                ('reference', models.CharField(blank=True, db_index=True, max_length=35, verbose_name='reference')),
                ('detail', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='remittanceinfo_set', to='jbank.StatementRecordDetail')),
            ],
        ),
        migrations.AddField(
            model_name='statement',
            name='file',
            field=models.ForeignKey(blank=True, default=None, null=True, on_delete=django.db.models.deletion.CASCADE, to='jbank.StatementFile'),
        ),
        migrations.CreateModel(
            name='ReferencePaymentRecord',
            fields=[
                ('accountentry_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='jacc.AccountEntry')),
                ('line_number', models.SmallIntegerField(blank=True, default=0, verbose_name='line number')),
                ('record_type', models.CharField(max_length=1, verbose_name='record type')),
                ('account_number', models.CharField(db_index=True, max_length=32, verbose_name='account number')),
                ('record_date', models.DateField(db_index=True, verbose_name='record date')),
                ('paid_date', models.DateField(blank=True, db_index=True, default=None, null=True, verbose_name='paid date')),
                ('archive_identifier', models.CharField(blank=True, db_index=True, default='', max_length=32, verbose_name='archive identifier')),
                ('remittance_info', models.CharField(db_index=True, max_length=32, verbose_name='remittance info')),
                ('payer_name', models.CharField(db_index=True, max_length=12, verbose_name='payer name')),
                ('currency_identifier', models.CharField(choices=[('1', 'EUR')], max_length=1, verbose_name='currency identifier')),
                ('name_source', models.CharField(blank=True, choices=[('', 'Not Set'), ('A', 'From Customer'), ('K', 'From Bank Clerk'), ('J', 'From Bank System')], max_length=1, verbose_name='name source')),
                ('correction_identifier', models.CharField(choices=[('0', 'Regular Entry'), ('1', 'Correction Entry')], max_length=1, verbose_name='correction identifier')),
                ('delivery_method', models.CharField(choices=[('A', 'From Customer'), ('K', 'From Bank Clerk'), ('J', 'From Bank System')], db_index=True, max_length=1, verbose_name='delivery method')),
                ('receipt_code', models.CharField(blank=True, choices=[('', ''), ('E', 'Separate'), ('P', 'Separate/Paper')], db_index=True, max_length=1, verbose_name='receipt code')),
                ('manually_settled', models.BooleanField(blank=True, db_index=True, default=False, verbose_name='manually settled')),
                ('batch', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='record_set', to='jbank.ReferencePaymentBatch', verbose_name='batch')),
            ],
            options={
                'verbose_name': 'reference payment records',
                'verbose_name_plural': 'reference payment records',
            },
            bases=('jacc.accountentry',),
        ),
        migrations.AddField(
            model_name='referencepaymentbatch',
            name='file',
            field=models.ForeignKey(blank=True, default=None, null=True, on_delete=django.db.models.deletion.CASCADE, to='jbank.ReferencePaymentBatchFile'),
        ),
        migrations.CreateModel(
            name='PayoutStatus',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', models.DateTimeField(blank=True, db_index=True, default=django.utils.timezone.now, editable=False, verbose_name='created')),
                ('file_name', models.CharField(blank=True, db_index=True, editable=False, max_length=255, verbose_name='file name')),
                ('response_code', models.CharField(blank=True, db_index=True, max_length=4, verbose_name='response code')),
                ('response_text', models.CharField(blank=True, max_length=128, verbose_name='response text')),
                ('msg_id', models.CharField(blank=True, db_index=True, max_length=64, verbose_name='message id')),
                ('original_msg_id', models.CharField(blank=True, db_index=True, max_length=64, verbose_name='original message id')),
                ('group_status', models.CharField(blank=True, db_index=True, max_length=8, verbose_name='group status')),
                ('status_reason', models.CharField(blank=True, max_length=255, verbose_name='status reason')),
                ('payout', models.ForeignKey(blank=True, default=None, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='payoutstatus_set', to='jbank.Payout', verbose_name='payout')),
            ],
            options={
                'verbose_name': 'payout status',
                'verbose_name_plural': 'payout statuses',
            },
        ),
        migrations.CreateModel(
            name='PayoutParty',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(db_index=True, max_length=128, verbose_name='name')),
                ('account_number', models.CharField(db_index=True, max_length=35, validators=[jutil.validators.iban_validator], verbose_name='account number')),
                ('bic', models.CharField(blank=True, db_index=True, max_length=16, verbose_name='BIC')),
                ('org_id', models.CharField(blank=True, db_index=True, default='', max_length=32, verbose_name='organization id')),
                ('address', models.TextField(blank=True, default='', verbose_name='address')),
                ('country_code', models.CharField(blank=True, db_index=True, default='FI', max_length=2, verbose_name='country code')),
                ('payouts_account', models.ForeignKey(blank=True, default=None, null=True, on_delete=django.db.models.deletion.PROTECT, to='jacc.Account', verbose_name='payouts account')),
            ],
            options={
                'verbose_name': 'payout party',
                'verbose_name_plural': 'payout parties',
            },
        ),
        migrations.AddField(
            model_name='payout',
            name='payer',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='+', to='jbank.PayoutParty', verbose_name='payer'),
        ),
        migrations.AddField(
            model_name='payout',
            name='recipient',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='+', to='jbank.PayoutParty', verbose_name='recipient'),
        ),
        migrations.AddField(
            model_name='currencyexchange',
            name='source',
            field=models.ForeignKey(blank=True, default=None, null=True, on_delete=django.db.models.deletion.PROTECT, to='jbank.CurrencyExchangeSource', verbose_name='currency exchange source'),
        ),
    ]
